/* linux/include/asm-arm/arch-ep93xx/debug-macro.S
 *
 * Debugging macro include header
 *
 *  Copyright (C) 1994-1999 Russell King
 *  Moved from linux/arch/arm/kernel/debug.S by Ray Lehtiniemi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
*/

                .macro  addruart,rx
                mrc     p15, 0, \rx, c1, c0
                tst     \rx, #1                         @ MMU enabled?
                ldreq   \rx, =IO_BASE_PHYS              @ System peripherals (phys address)
                ldrne   \rx, =IO_BASE_VIRT              @ System peripherals (virt address)
                orr     \rx,\rx,#0x008c0000             @ Advance to UART1Base

                @ We probe for the active serial port here.
                @ We assume r1 can be clobbered.

                @ see if UART1 is active
                ldr     r1, [\rx, #0x14]                @UART1Ctrl
                tst     r1, #1

                @ if UART1 is inactive advance to UART2
                addeq   \rx, \rx, #0x00010000
                ldreq   r1, [\rx, #0x14]                @UART2Ctrl
                tsteq   r1, #1

                @ if UART2 is inactive advance to UART3
                addeq   \rx, \rx, #0x00010000
                ldreq   r1, [\rx, #0x14]                @UART3Ctrl
                tsteq   r1, #1

                @ if all ports are inactive, then there is nothing we can do
                moveq   pc, lr
                .endm

                .macro  senduart,rd,rx
                strb    \rd, [\rx]                      @ UARTxData
                .endm

                .macro  waituart,rd,rx
1001:           ldr     \rd, [\rx, #0x18]               @ UARTxFlag
                tst     \rd, #0x20                      @ TXFF = 0 when ok to transmit
                bne     1001b
                .endm

                .macro  busyuart,rd,rx
1001:           ldr     \rd, [\rx, #0x18]               @ UARTxFlag
                tst     \rd, #0x08                      @ BUSY = 1 while transmitting
                bne     1001b
                .endm
